// copyright (2019.) Marko Čupić - Fakultet elektrotehnike i računarstva, Sveučilište u Zagrebu; nije dozvoljena uporaba u vlastitim projektima, prerada ili daljna distribucija bez dozvole autora

vector.prototype.rightMultiplyBy = function(m) {
  if(this.elems.length != m.rows) throw "Incompatible vector-matrix multiplication.";
  let res = [];
  for(let c = 0; c < m.cols; c++) {
    let sum = 0;
    for(let r = 0; r < this.elems.length; r++) {
      sum += this.elems[r]*m.data[r][c];
    }
    res.push(sum);
  }
  return new vector(res);
}

